Index: graph_displayer_canvas-event.cc
===================================================================
--- graph_displayer_canvas-event.cc	(revision 201)
+++ graph_displayer_canvas-event.cc	(revision 187)
@@ -17,7 +17,5 @@
  */
 
-#include <graph_displayer_canvas.h>
-#include <mapstorage.h>
-#include <nbtab.h>
+#include "graph_displayer_canvas.h"
 #include <cmath>
 
@@ -34,61 +32,61 @@
 {
   if(actual_tool!=newtool)
-  {
-
-    actual_handler.disconnect();
-
-    switch(actual_tool)
-    {
-      case CREATE_EDGE:
-        {
-          GdkEvent * generated=new GdkEvent();
-          generated->type=GDK_BUTTON_RELEASE;
-          generated->button.button=3;
-          createEdgeEventHandler(generated);      
-          break;
-        }
-      case MAP_EDIT:
-        {
-          break;
-        }
-      default:
-        break;
-    }
-
-    active_item=NULL; 
-    target_item=NULL; 
-    active_edge=INVALID;	
-    active_node=INVALID;	
-
-
-    actual_tool=newtool;
-
-    switch(newtool)
-    {
-      case MOVE:
-        actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::moveEventHandler), false);
-        break;
-
-      case CREATE_NODE:
-        actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createNodeEventHandler), false);
-        break;
-
-      case CREATE_EDGE:
-        actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createEdgeEventHandler), false);
-        break;
-
-      case ERASER:
-        actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::eraserEventHandler), false);
-        break;
-
-      case MAP_EDIT:
-        grab_focus();
-        actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::mapEditEventHandler), false);
-        break;
-
-      default:
-        break;
-    }
-  }
+    {
+
+      actual_handler.disconnect();
+
+      switch(actual_tool)
+	{
+	case CREATE_EDGE:
+	  {
+	    GdkEvent * generated=new GdkEvent();
+	    generated->type=GDK_BUTTON_RELEASE;
+	    generated->button.button=3;
+	    createEdgeEventHandler(generated);      
+	    break;
+	  }
+	case MAP_EDIT:
+	  {
+	    break;
+	  }
+	default:
+	  break;
+	}
+
+      active_item=NULL; 
+      target_item=NULL; 
+      active_edge=INVALID;	
+      active_node=INVALID;	
+
+
+      actual_tool=newtool;
+  
+      switch(newtool)
+	{
+	case MOVE:
+	  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::moveEventHandler), false);
+	  break;
+
+	case CREATE_NODE:
+	  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createNodeEventHandler), false);
+	  break;
+
+	case CREATE_EDGE:
+	  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::createEdgeEventHandler), false);
+	  break;
+
+	case ERASER:
+	  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::eraserEventHandler), false);
+	  break;
+
+	case MAP_EDIT:
+	  grab_focus();
+	  actual_handler=signal_event().connect(sigc::mem_fun(*this, &GraphDisplayerCanvas::mapEditEventHandler), false);
+	  break;
+
+	default:
+	  break;
+	}
+    }
 }
 
@@ -139,30 +137,28 @@
 bool GraphDisplayerCanvas::moveEventHandler(GdkEvent* e)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   static Gnome::Canvas::Text *coord_text = 0;
   switch(e->type)
-  {
+    {
     case GDK_BUTTON_PRESS:
       //we mark the location of the event to be able to calculate parameters of dragging
       window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
-
+      
       active_item=(get_item_at(clicked_x, clicked_y));
       active_node=INVALID;
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
-      {
-        if(nodesmap[i]==active_item)
-        {
-          active_node=i;
-        }
-      }
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  if(nodesmap[i]==active_item)
+	    {
+	      active_node=i;
+	    }
+	}
       isbutton=e->button.button;
       break;
     case GDK_BUTTON_RELEASE:
       if (coord_text)
-      {
-        delete coord_text;
-        coord_text = 0;
-      }
+	{
+	  delete coord_text;
+	  coord_text = 0;
+	}
       isbutton=0;
       active_item=NULL;
@@ -172,57 +168,57 @@
       //we only have to do sg. if the mouse button is pressed AND the click was on a node that was found in the set of nodes
       if(active_node!=INVALID)
-      {
-        ms.setModified();
-
-        //new coordinates will be the old values,
-        //because the item will be moved to the
-        //new coordinate therefore the new movement
-        //has to be calculated from here
-
-        double new_x, new_y;
-
-        window_to_world (e->motion.x, e->motion.y, new_x, new_y);
-
-        double dx=new_x-clicked_x;
-        double dy=new_y-clicked_y;
-
-        moveNode(dx, dy);
-
-        clicked_x=new_x;
-        clicked_y=new_y;
-
-        // reposition the coordinates text
-        std::ostringstream ostr;
-        ostr << "(" <<
-          ms.getNodeCoords(active_node).x << ", " <<
-          ms.getNodeCoords(active_node).y << ")";
-        double radius =
-          (nodesmap[active_node]->property_x2().get_value() -
-           nodesmap[active_node]->property_x1().get_value()) / 2.0;
-        if (coord_text)
-        {
-          coord_text->property_text().set_value(ostr.str());
-          coord_text->property_x().set_value(
-              ms.getNodeCoords(active_node).x + radius);
-          coord_text->property_y().set_value(
-              ms.getNodeCoords(active_node).y - radius);
-        }
-        else
-        {
-          coord_text = new Gnome::Canvas::Text(
-              displayed_graph,
-              ms.getNodeCoords(active_node).x + radius,
-              ms.getNodeCoords(active_node).y - radius,
-              ostr.str());
-          coord_text->property_fill_color().set_value("black");
-          coord_text->property_anchor().set_value(Gtk::ANCHOR_SOUTH_WEST);
-        }
-
-
-      }
+	{
+	  (mytab.mapstorage).modified = true;
+	  
+	  //new coordinates will be the old values,
+	  //because the item will be moved to the
+	  //new coordinate therefore the new movement
+	  //has to be calculated from here
+	  
+	  double new_x, new_y;
+	  
+	  window_to_world (e->motion.x, e->motion.y, new_x, new_y);
+	  
+	  double dx=new_x-clicked_x;
+	  double dy=new_y-clicked_y;
+	  
+	  moveNode(dx, dy);
+
+	  clicked_x=new_x;
+	  clicked_y=new_y;
+
+	  // reposition the coordinates text
+	  std::ostringstream ostr;
+	  ostr << "(" <<
+	    (mytab.mapstorage).coords[active_node].x << ", " <<
+	    (mytab.mapstorage).coords[active_node].y << ")";
+	  double radius =
+	    (nodesmap[active_node]->property_x2().get_value() -
+	     nodesmap[active_node]->property_x1().get_value()) / 2.0;
+	  if (coord_text)
+	    {
+	      coord_text->property_text().set_value(ostr.str());
+	      coord_text->property_x().set_value((mytab.mapstorage).coords[active_node].x +
+						 radius);
+	      coord_text->property_y().set_value((mytab.mapstorage).coords[active_node].y -
+						 radius);
+	    }
+	  else
+	    {
+	      coord_text = new Gnome::Canvas::Text(
+						   displayed_graph,
+						   (mytab.mapstorage).coords[active_node].x + radius,
+						   (mytab.mapstorage).coords[active_node].y - radius,
+						   ostr.str());
+	      coord_text->property_fill_color().set_value("black");
+	      coord_text->property_anchor().set_value(Gtk::ANCHOR_SOUTH_WEST);
+	    }
+
+
+	}
     default: break;
-  }
-
-  return false;
+    }
+
+return false;
 }
 
@@ -230,5 +226,5 @@
 {
   switch(move_code)
-  {
+    {
     case 1:
       return XY((moved_node_2.x + fix_node.x) / 2.0, (moved_node_2.y + fix_node.y) / 2.0);
@@ -239,50 +235,50 @@
     case 3:
       {
-        //////////////////////////////////////////////////////////////////////////////////////////////////////
-        /////////// keeps shape-with scalar multiplication - version 2.
-        //////////////////////////////////////////////////////////////////////////////////////////////////////
-
-        //old vector from one to the other node - a
-        XY a_v(moved_node_1.x-fix_node.x,moved_node_1.y-fix_node.y);
-        //new vector from one to the other node - b
-        XY b_v(moved_node_2.x-fix_node.x,moved_node_2.y-fix_node.y);
-
-        double absa=sqrt(a_v.normSquare());
-        double absb=sqrt(b_v.normSquare());
-
-        if ((absa == 0.0) || (absb == 0.0))
-        {
-          return old_arrow_pos;
-        }
-        else
-        {
-          //old vector from one node to the breakpoint - c
-          XY c_v(old_arrow_pos.x-fix_node.x,old_arrow_pos.y-fix_node.y);
-
-          //unit vector with the same direction to a_v
-          XY a_v_u(a_v.x/absa,a_v.y/absa);
-
-          //normal vector of unit vector with the same direction to a_v
-          XY a_v_u_n(((-1)*a_v_u.y),a_v_u.x);
-
-          //unit vector with the same direction to b_v
-          XY b_v_u(b_v.x/absb,b_v.y/absb);
-
-          //normal vector of unit vector with the same direction to b_v
-          XY b_v_u_n(((-1)*b_v_u.y),b_v_u.x);
-
-          //vector c in a_v_u and a_v_u_n co-ordinate system
-          XY c_a(c_v*a_v_u,c_v*a_v_u_n);
-
-          //new vector from one node to the breakpoint - d - we have to calculate this one
-          XY d_v=absb/absa*(c_a.x*b_v_u+c_a.y*b_v_u_n);
-
-          return XY(d_v.x+fix_node.x,d_v.y+fix_node.y);
-        }
-        break;
+	//////////////////////////////////////////////////////////////////////////////////////////////////////
+	/////////// keeps shape-with scalar multiplication - version 2.
+	//////////////////////////////////////////////////////////////////////////////////////////////////////
+
+	//old vector from one to the other node - a
+	XY a_v(moved_node_1.x-fix_node.x,moved_node_1.y-fix_node.y);
+	//new vector from one to the other node - b
+	XY b_v(moved_node_2.x-fix_node.x,moved_node_2.y-fix_node.y);
+
+	double absa=sqrt(a_v.normSquare());
+	double absb=sqrt(b_v.normSquare());
+
+	if ((absa == 0.0) || (absb == 0.0))
+	  {
+	    return old_arrow_pos;
+	  }
+	else
+	  {
+	    //old vector from one node to the breakpoint - c
+	    XY c_v(old_arrow_pos.x-fix_node.x,old_arrow_pos.y-fix_node.y);
+
+	    //unit vector with the same direction to a_v
+	    XY a_v_u(a_v.x/absa,a_v.y/absa);
+
+	    //normal vector of unit vector with the same direction to a_v
+	    XY a_v_u_n(((-1)*a_v_u.y),a_v_u.x);
+
+	    //unit vector with the same direction to b_v
+	    XY b_v_u(b_v.x/absb,b_v.y/absb);
+
+	    //normal vector of unit vector with the same direction to b_v
+	    XY b_v_u_n(((-1)*b_v_u.y),b_v_u.x);
+
+	    //vector c in a_v_u and a_v_u_n co-ordinate system
+	    XY c_a(c_v*a_v_u,c_v*a_v_u_n);
+
+	    //new vector from one node to the breakpoint - d - we have to calculate this one
+	    XY d_v=absb/absa*(c_a.x*b_v_u+c_a.y*b_v_u_n);
+
+	    return XY(d_v.x+fix_node.x,d_v.y+fix_node.y);
+	  }
+	break;
       }
     default:
       break;
-  }
+    }
 }
 
@@ -290,6 +286,4 @@
 bool GraphDisplayerCanvas::createNodeEventHandler(GdkEvent* e)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   switch(e->type)
   {
@@ -306,5 +300,5 @@
 
     case GDK_BUTTON_RELEASE:
-      ms.setModified();
+      (mytab.mapstorage).modified = true;
 
       is_drawn=true;
@@ -312,7 +306,27 @@
       isbutton=1;
 
+      active_node=(mytab.mapstorage).graph.addNode();
+
+      //initiating values corresponding to new node in maps
+
       window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
 
-      active_node = ms.addNode(XY(clicked_x, clicked_y));
+      // update coordinates
+      (mytab.mapstorage).coords.set(active_node, XY(clicked_x, clicked_y));
+
+      // update all other maps
+      for (std::map<std::string, Graph::NodeMap<double>*>::const_iterator it =
+          (mytab.mapstorage).nodemap_storage.begin(); it !=
+          (mytab.mapstorage).nodemap_storage.end(); ++it)
+      {
+        if ((it->first != "coordinates_x") &&
+            (it->first != "coordinates_y"))
+        {
+          (*(it->second))[active_node] =
+            (mytab.mapstorage).nodemap_default[it->first];
+        }
+      }
+      // increment the id map's default value
+      (mytab.mapstorage).nodemap_default["label"] += 1.0;
 
       nodesmap[active_node]=new Gnome::Canvas::Ellipse(displayed_graph,
@@ -333,5 +347,5 @@
       nodetextmap[active_node]->raise_to_top();
 
-      //       mapwin.updateNode(active_node);
+//       mapwin.updateNode(active_node);
       propertyUpdate(active_node);
 
@@ -349,6 +363,4 @@
 bool GraphDisplayerCanvas::createEdgeEventHandler(GdkEvent* e)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   switch(e->type)
   {
@@ -366,5 +378,5 @@
           active_item=(get_item_at(clicked_x, clicked_y));
           active_node=INVALID;
-          for (NodeIt i(ms.graph); i!=INVALID; ++i)
+          for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
           {
             if(nodesmap[i]==active_item)
@@ -395,5 +407,5 @@
           target_item=(get_item_at(clicked_x, clicked_y));
           Node target_node=INVALID;
-          for (NodeIt i(ms.graph); i!=INVALID; ++i)
+          for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
           {
             if(nodesmap[i]==target_item)
@@ -405,22 +417,52 @@
           if(target_node!=INVALID)
           {
-            ms.setModified();
+            (mytab.mapstorage).modified = true;
 
             *(nodesmap[target_node]) <<
               Gnome::Canvas::Properties::fill_color("red");
 
-            active_edge = ms.addEdge(active_node, target_node);
+            //creating new edge
+            active_edge=(mytab.mapstorage).graph.addEdge(active_node,
+                target_node);
+
+            // update maps
+            for (std::map<std::string,
+                Graph::EdgeMap<double>*>::const_iterator it =
+                (mytab.mapstorage).edgemap_storage.begin(); it !=
+                (mytab.mapstorage).edgemap_storage.end(); ++it)
+            {
+              (*(it->second))[active_edge] =
+                (mytab.mapstorage).edgemap_default[it->first];
+            }
+            // increment the id map's default value
+            (mytab.mapstorage).edgemap_default["label"] += 1.0;
 
             if(target_node!=active_node)		
             {
-              edgesmap[active_edge]=new BrokenEdge(displayed_graph, active_edge, *this);
+              // set the coordinates of the arrow on the new edge
+              MapStorage& ms = mytab.mapstorage;
+              ms.arrow_pos.set(active_edge,
+                  (ms.coords[ms.graph.source(active_edge)] +
+                   ms.coords[ms.graph.target(active_edge)])/ 2.0);
+
+              //drawing new edge
+              edgesmap[active_edge]=new BrokenEdge(displayed_graph, active_edge,
+                  *this);
             }
             else
             {
-              edgesmap[active_edge]=new LoopEdge(displayed_graph, active_edge, *this);
+              // set the coordinates of the arrow on the new edge
+              MapStorage& ms = mytab.mapstorage;
+              ms.arrow_pos.set(active_edge,
+                  (ms.coords[ms.graph.source(active_edge)] +
+                   XY(0.0, 80.0)));
+
+              //drawing new edge
+              edgesmap[active_edge]=new LoopEdge(displayed_graph, active_edge,
+                  *this);
             }
 
             //initializing edge-text as well, to empty string
-            XY text_pos=ms.getArrowCoords(active_edge);
+            XY text_pos=mytab.mapstorage.arrow_pos[active_edge];
             text_pos+=(XY(10,10));
 
@@ -451,10 +493,10 @@
         if(active_item)
         {
-          propertyUpdate(active_node,N_COLOR);
+	  propertyUpdate(active_node,N_COLOR);
           active_item=NULL;
         }
         if(target_item)
         {
-          propertyUpdate(ms.graph.target(active_edge),N_COLOR);
+	  propertyUpdate((mytab.mapstorage).graph.target(active_edge),N_COLOR);
           target_item=NULL;
         }
@@ -471,8 +513,6 @@
 bool GraphDisplayerCanvas::eraserEventHandler(GdkEvent* e)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   switch(e->type)
-  {
+    {
     case GDK_BUTTON_PRESS:
       //finding the clicked items
@@ -482,31 +522,31 @@
       active_edge=INVALID;
       //was it a node?
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
-      {
-        if(nodesmap[i]==active_item)
-        {
-          active_node=i;
-        }
-      }
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  if(nodesmap[i]==active_item)
+	    {
+	      active_node=i;
+	    }
+	}
       //or was it an edge?
       if(active_node==INVALID)
-      {
-        for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-        {
-          if(edgesmap[i]->getLine()==active_item)
-          {
-            active_edge=i;
-          }
-        }
-      }
+	{
+	  for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	    {
+	      if(edgesmap[i]->getLine()==active_item)
+		{
+		  active_edge=i;
+		}
+	    }
+	}
 
       // return if the clicked object is neither an edge nor a node
       if (active_edge == INVALID) return false;
-
+      
       //recolor activated item
       if(active_item)
-      {
-        *active_item << Gnome::Canvas::Properties::fill_color("red");
-      }
+	{
+	  *active_item << Gnome::Canvas::Properties::fill_color("red");
+	}
       break;
 
@@ -514,54 +554,54 @@
       window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
       if(active_item)
-      {
-        //the cursor was not moved since pressing it
-        if( active_item == ( get_item_at (clicked_x, clicked_y) ) )
-        {
-          //a node was found
-          if(active_node!=INVALID)
-          {
-            ms.setModified();
-
-            std::set<Graph::Edge> edges_to_delete;
-
-            for(OutEdgeIt e(ms.graph,active_node);e!=INVALID;++e)
-            {
-              edges_to_delete.insert(e);
-            }
-
-            for(InEdgeIt e(ms.graph,active_node);e!=INVALID;++e)
-            {
-              edges_to_delete.insert(e);
-            }
-
-            //deleting collected edges
-            for(std::set<Graph::Edge>::iterator
-                edge_set_it=edges_to_delete.begin();
-                edge_set_it!=edges_to_delete.end();
-                ++edge_set_it)
-            {
-              deleteItem(*edge_set_it);
-            }
-            deleteItem(active_node);
-          }
-          //a simple edge was chosen
-          else if (active_edge != INVALID)
-          {
-            deleteItem(active_edge);
-          }
-        }
-        //pointer was moved, deletion is cancelled
-        else
-        {
-          if(active_node!=INVALID)
-          {
-            *active_item << Gnome::Canvas::Properties::fill_color("blue");
-          }
-          else if (active_edge != INVALID)
-          {
-            *active_item << Gnome::Canvas::Properties::fill_color("green");
-          }
-        }
-      }
+	{
+	  //the cursor was not moved since pressing it
+	  if( active_item == ( get_item_at (clicked_x, clicked_y) ) )
+	    {
+	      //a node was found
+	      if(active_node!=INVALID)
+		{
+                  (mytab.mapstorage).modified = true;
+
+		  std::set<Graph::Edge> edges_to_delete;
+
+		  for(OutEdgeIt e((mytab.mapstorage).graph,active_node);e!=INVALID;++e)
+		    {
+		      edges_to_delete.insert(e);
+		    }
+		  
+		  for(InEdgeIt e((mytab.mapstorage).graph,active_node);e!=INVALID;++e)
+		    {
+		      edges_to_delete.insert(e);
+		    }
+		  
+		  //deleting collected edges
+		  for(std::set<Graph::Edge>::iterator
+			edge_set_it=edges_to_delete.begin();
+		      edge_set_it!=edges_to_delete.end();
+		      ++edge_set_it)
+		    {
+		      deleteItem(*edge_set_it);
+		    }
+		  deleteItem(active_node);
+		}
+	      //a simple edge was chosen
+	      else if (active_edge != INVALID)
+		{
+		  deleteItem(active_edge);
+		}
+	    }
+	  //pointer was moved, deletion is cancelled
+	  else
+	    {
+	      if(active_node!=INVALID)
+		{
+		  *active_item << Gnome::Canvas::Properties::fill_color("blue");
+		}
+	      else if (active_edge != INVALID)
+		{
+		  *active_item << Gnome::Canvas::Properties::fill_color("green");
+		}
+	    }
+	}
       //reseting datas
       active_item=NULL;
@@ -575,5 +615,5 @@
     default:
       break;
-  }
+    }
   return false;
 }
